header
{
/**
 * Semantic analysis for the Mile++ Language.
 * 
 * @author Ricardo Soto
 * @since 1.5
 */

package cl.ucv.inf.mileppcompiler.compilers;

}

  
class MilePPTreeParser2ndPass extends TreeParser;
options
{
    importVocab=MilePPParserVocab;
    buildAST = false;
    defaultErrorHandler=false;
}

{
private SemanticInspector   sI = new SemanticInspector();
private String classId = "";

	public void setId(AST id) {
		this.classId = id.toString();
	}
	
	public String getId() {
		return classId;
	}



}

//==================================================
//Program

program  : #(PROGRAM main_class_dec (class_dec)*);


//======================================================= 
//Class declarations
        
main_class_dec : #(MAIN_RW class_dec);


class_dec : #(CLASS_RW id1:IDENT {this.setId(id1);}
             (EXTENDS_RW id2:IDENT {sI.checkExtends(id1,id2);} )? 
             (param)? class_body);

param :  #(PARAM type IDENT (COMMA type IDENT)*);
         
class_body : #(BODY var_dec method_dec);


//=======================================================
// Var dec

var_dec : #(VAR_DEC (basic_var_dec| object_dec)*);

basic_var_dec : #(BASIC_VAR_DEC basic_type IDENT);

object_dec : #(OBJECT_RW id1:IDENT id2:IDENT {sI.checkObject(id1,id2);});
          
type:     basic_type|IDENT;

basic_type:   (NUMERIC_TYPE|STRING_TYPE) ;

//=======================================================
// Method dec

method_dec : #(METHOD_RW (type IDENT  (param)? var_dec body return_st)*);
              
return_st : #(RETURN_RW expr);

//=======================================================
// Body

body : #(BODY (assign)*);
        
         
//=======================================================
// Assignment

assign : #(ASSIGN id1:IDENT ASSIG id2:expr 
           {sI.addConstantIfExists(this.getId(),id1,id2);});
        
                 
//=================================================
//Expressions

expr
  : #(OR_RW           expr expr) 
  | #(AND_RW          expr expr) 
  | #(EQUAL           expr expr) 
  | #(GR_EQUAL        expr expr)  
  | #(NOT_EQUAL       expr expr) 
  | #(GR              expr expr) 
  | #(LE              expr expr) 
  | #(PLUS            expr expr) 
  | #(SUB             expr expr) 
  | #(STAR            expr expr) 
  | #(SLASH           expr expr) 

  | #(UN_MINUS                   expr)
  | #(RES_NOT                    expr) 
  | IDENT 
  | lit
  | access
  ;

  lit: REAL_LITERAL|INT_LITERAL;
  
  access : #(ACCESS (IDENT (DOT IDENT | access_param)*));

  access_param: #(ACCESS_PARAM (IDENT (COMMA IDENT)*)? );